/*
 * Small AJAX framework
 */
function ajax_request_callback(req)
{
    if (req.readyState == 4 && req.status == 200) {
	var data = json_parse(req.responseText);

	if (req.oncomplete)
	    req.oncomplete(data);
    }
}

function ajax_request(func,params,oncomplete)
{
    var req = new XMLHttpRequest();
    if (!req) return;

    var params = 'func=' + func + '&' + params;
    req.open ("POST", 'ajax/ajax.php');
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    req.setRequestHeader("Content-length", params.length);
    req.setRequestHeader("Connection", "close");
    if (typeof oncomplete == 'function') {
	req.onreadystatechange = function() { ajax_request_callback(req); }
	req.oncomplete = oncomplete;
    }
    req.send(params);
}

function set_value(id, value)
{
    var obj = document.getElementById(id);
    if (!obj) return;

    if (obj.nodeName.toLowerCase() == 'input'
	&& obj.type.toLowerCase() == 'checkbox')
	if (value) obj.checked = true;
	else obj.checked = false;
    else if (obj.nodeName.toLowerCase() == 'input'
	|| obj.nodeName.toLowerCase() == 'textarea')
	obj.value = value;
    else if (obj.nodeName.toLowerCase() == 'span')
	obj.innerHTML = value;
    else if (obj.nodeName.toLowerCase() == 'select')
	for (var i=0; i < obj.options.length; i++)
	    if (obj.options[i].value == value)
		obj.selectedIndex = i;
}

/*
 * Form functions
 */
function form_save(obj)
{
    return false;
}

/*
 * Table functions
 */
function details_callback(data)
{
    for (var id in data)
	set_value('detail_'+id, data[id]);
}

function fetch_callback(data)
{
    for (var id in data)
	set_value('edit_'+id, data[id]);
}

/*
 * Rico functions
 */
function gridDrillDown(e)
{
    if (e.originalTarget && e.originalTarget.target && e.originalTarget.target == '_top')
	return;

    var id = 0; // Column 0 contains ID
    var row = grid.edit.drillDown(e,0,0);
    var cell = grid.columns[id].cell(row);
    if (!cell) return;
    var value = cell.innerHTML;

    if (document.getElementById('details')) {
	var params = 'source=' + grid.tableId.substr(5) + '&id=' + value;
	ajax_request('details', params, details_callback);
    }

    if (document.getElementById('form_edit')) {
	var params = 'source=' + grid.tableId.substr(5) + '&id=' + value;
	ajax_request('fetch', params, fetch_callback);
    }
}
